package ch.actifsource.demo.osgitimeoutbase;

import java.util.Arrays;
import java.util.Comparator;
import java.util.concurrent.CountDownLatch;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {

	@Override
	public void start(BundleContext context) throws Exception {
		IConfigurationElement[] elements = sort(Platform.getExtensionRegistry()
				.getConfigurationElementsFor(
						"ch.actifsource.demo.osgiTimeoutBase.loadbundle"));
		for (final IConfigurationElement element : elements) {
			if (element.getName().equals("load")) {
				System.out.println("loading: "
						+ element.getContributor().getName());
				new Thread(new Runnable() {

					@Override
					public void run() {
						try {
							element.createExecutableExtension("class");
						} catch (CoreException e) {
							e.printStackTrace();
						}

					}
				}) {

					private CountDownLatch fStarted = new CountDownLatch(1);

					public void startAndJoinStarted() {
						start();
						try {
							fStarted.await();
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}

					@Override
					public void run() {
						fStarted.countDown();
						super.run();
					}

				}.startAndJoinStarted();

			}
		}
	}

	private IConfigurationElement[] sort(
			IConfigurationElement[] configurationElementsFor) {
		Arrays.sort(configurationElementsFor,
				new Comparator<IConfigurationElement>() {

					@Override
					public int compare(IConfigurationElement o1,
							IConfigurationElement o2) {
						return o1.getContributor().getName()
								.compareTo(o2.getContributor().getName());
					}
				});
		return configurationElementsFor;
	}

	@Override
	public void stop(BundleContext context) throws Exception {

	}

}
